﻿using UnityEngine;
using System.Collections;
using System.Diagnostics;

public class ShadowView : MonoBehaviour {

    public CanvasGroup c1;
    public CanvasGroup c2;
    public CanvasGroup c3;
    public CanvasGroup c4;

    float factorC1 = 1 / 0.3f;
    float factorC2 = 1 / 0.5f;
    float factorC3 = 1 / 0.8f;
    float factorC4 = 1 / 1.2f;

    int timeToFullUpdate = 3000; // milisecs
    static Stopwatch sw = new Stopwatch();
    static float baseVal = 0.0f;
    static float newVal = 0.0f;
    static float currentVal = 0.0f;
    public static void addTarget(float shadowIntensity) {
        baseVal = currentVal;
        newVal = shadowIntensity;
        sw.Reset();
        sw.Start();
    }

    // Use this for initialization
    void Start () {
        sw.Start();
	}
	
	// Update is called once per frame
	void Update () {
        if (sw.ElapsedMilliseconds < timeToFullUpdate)
            currentVal = Mathf.Lerp(baseVal, newVal, ((float)sw.ElapsedMilliseconds) / timeToFullUpdate);
        c1.alpha = factorC1 * currentVal;
        c2.alpha = factorC2 * currentVal;
        c3.alpha = factorC3 * currentVal;
        c4.alpha = factorC4 * currentVal;
        //UnityEngine.Debug.Log(sw.ElapsedMilliseconds + "_" + currentVal + "_" + timeToFullUpdate);
        // For testing:
        //if (Input.GetKey(KeyCode.Z))
        //    addTarget(0.0f);
        //if (Input.GetKey(KeyCode.A))
        //    addTarget(0.2f);
        //if (Input.GetKey(KeyCode.S))
        //    addTarget(0.4f);
        //if (Input.GetKey(KeyCode.D))
        //    addTarget(0.7f);
        //if (Input.GetKey(KeyCode.F))
        //    addTarget(1.0f);
    }
}
